module "s3_bucket" {
  source                                     = "terraform-aws-modules/s3-bucket/aws"
  version                                    = "3.13.0"
  for_each                                   = var.s3_buckets
  bucket                                     = each.key
  attach_elb_log_delivery_policy             = try(each.value.attach_elb_log_delivery_policy, var.attach_elb_log_delivery_policy)
  attach_lb_log_delivery_policy              = try(each.value.attach_lb_log_delivery_policy, var.attach_lb_log_delivery_policy)
  attach_access_log_delivery_policy          = try(each.value.attach_access_log_delivery_policy, var.attach_access_log_delivery_policy)
  attach_deny_insecure_transport_policy      = try(each.value.attach_deny_insecure_transport_policy, var.attach_deny_insecure_transport_policy)
  attach_require_latest_tls_policy           = try(each.value.attach_require_latest_tls_policy, var.attach_require_latest_tls_policy)
  attach_policy                              = try(each.value.attach_policy, var.attach_policy)
  attach_public_policy                       = try(each.value.attach_public_policy, var.attach_public_policy)
  attach_inventory_destination_policy        = try(each.value.attach_inventory_destination_policy, var.attach_inventory_destination_policy)
  attach_analytics_destination_policy        = try(each.value.attach_analytics_destination_policy, var.attach_analytics_destination_policy)
  bucket_prefix                              = try(each.value.bucket_prefix, var.bucket_prefix)
  acl                                        = try(each.value.acl, var.acl)
  policy                                     = try(each.value.policy, var.policy)
  tags                                       = try(each.value.tags, var.tags)
  force_destroy                              = try(each.value.force_destroy, var.force_destroy)
  acceleration_status                        = try(each.value.acceleration_status, var.acceleration_status)
  request_payer                              = try(each.value.request_payer, var.request_payer)
  website                                    = try(each.value.website, var.website)
  cors_rule                                  = try(each.value.cors_rule, var.cors_rule)
  versioning                                 = try(each.value.versioning, var.versioning)
  logging                                    = try(each.value.logging, var.logging)
  access_log_delivery_policy_source_buckets  = try(each.value.access_log_delivery_policy_source_buckets, var.access_log_delivery_policy_source_buckets)
  access_log_delivery_policy_source_accounts = try(each.value.access_log_delivery_policy_source_accounts, var.access_log_delivery_policy_source_accounts)
  grant                                      = try(each.value.grant, var.grant)
  owner                                      = try(each.value.owner, var.owner)
  expected_bucket_owner                      = try(each.value.expected_bucket_owner, var.expected_bucket_owner)
  lifecycle_rule                             = try(each.value.lifecycle_rule, var.lifecycle_rule)
  replication_configuration                  = try(each.value.replication_configuration, var.replication_configuration)
  server_side_encryption_configuration       = try(each.value.server_side_encryption_configuration, var.server_side_encryption_configuration)
  intelligent_tiering                        = try(each.value.intelligent_tiering, var.intelligent_tiering)
  object_lock_configuration                  = try(each.value.object_lock_configuration, var.object_lock_configuration)
  metric_configuration                       = try(each.value.metric_configuration, var.metric_configuration)
  inventory_configuration                    = try(each.value.inventory_configuration, var.inventory_configuration)
  inventory_source_account_id                = try(each.value.inventory_source_account_id, var.inventory_source_account_id)
  inventory_source_bucket_arn                = try(each.value.inventory_source_bucket_arn, var.inventory_source_bucket_arn)
  inventory_self_source_destination          = try(each.value.inventory_self_source_destination, var.inventory_self_source_destination)
  analytics_configuration                    = try(each.value.analytics_configuration, var.analytics_configuration)
  analytics_source_account_id                = try(each.value.analytics_source_account_id, var.analytics_source_account_id)
  analytics_source_bucket_arn                = try(each.value.analytics_source_bucket_arn, var.analytics_source_bucket_arn)
  analytics_self_source_destination          = try(each.value.analytics_self_source_destination, var.analytics_self_source_destination)
  object_lock_enabled                        = try(each.value.object_lock_enabled, var.object_lock_enabled)
  block_public_acls                          = try(each.value.block_public_acls, var.block_public_acls)
  block_public_policy                        = try(each.value.block_public_policy, var.block_public_policy)
  ignore_public_acls                         = try(each.value.ignore_public_acls, var.ignore_public_acls)
  restrict_public_buckets                    = try(each.value.restrict_public_buckets, var.restrict_public_buckets)
  control_object_ownership                   = try(each.value.control_object_ownership, var.control_object_ownership)
  object_ownership                           = try(each.value.object_ownership, var.object_ownership)
}